Rando Note #7

Translated version

Terminology: To "solve some points" means to come up with a solution capable of getting such specific points.

The 2025 Sichuan provincial team selection contest review.

If any of us cdqz people still got balls and don't wanna get rekt by cfls and cdjx in the next season then do something instead of barking all day

Contest Time Review

I didn't really have an image of the difficulty of the contest. Based on my experience last year, I thought that the problems would be very hard and I would consider myself very lucky if I could solve the first problem. However, the real contest seemed somewhat easier than what I imagined.

Day 1

5 minutes after the contest started and everyone starts to crunch their keyboard. This might be a sign that the prob A is easy. Few minutes later, I also have a solution for the prob A. I successfully passed all large samples after \(34\) minutes. A good start!

Then I gave prob B and prob C a glance. I tackled prob B for \(30\) minutes, realized that it must be solved with something new in \(O(q\operatorname{polylog}(n)\omega^{-1})\) and was probably a DS. After \(60\) minutes of digging, I was able to solve \(32\) points. Since I might be able to solve more points later as there was still much time, so I decided to implement the brute force solution for C first. Then I left problem B without implementing anything. It was \(10:00\).

I spent 30 minutes writing a brute force for prob C. There was some back and forth, and I misread the statement for once. As expected, I successfully implemented the \(8\) points solution.

At this time, the clock is now ticking as it is near \(10:40\), the implementation for prob B is kinda messy, so I decided to preserve \(90\) minutes to implement the solution. At \(11:30\), I can solve \(60\) points and was forced to start implementing because of the tight time. It turned out to be the correct decision, as there was only \(15\) minutes left when I passed the samples. The execution time on samples seems a bit tight, so I tried to optimize the constant factor in the rest of the time with some mystical code reorganization and hope that I would pass.

Day 2

你昨天打了 \(150\)~\(160\) 分,如果今天题太难的话该打的暴力要打哦 —— ly

I expected Day 2 problems to be significantly harder than Day 1 problems. However, I was wrong again.

5 minutes after the contest begins everyone started to crunch their keyboard again. This time A was again an easy problem, with standard segment tree binary search trick. It took me \(60\) minutes to complete the problem, probably due to the fact that I was a bit over-excited and forgot to call build() for my segment tree.

Then I understood the statement of prob B and prob C fast. I was able to make some observations in prob C, after devising for some time, I was able to solve 32 points at \(10:00\). I left the problem without implementation.

Then I spend a whole \(90\) minutes trying to solve prob B. For some reason I was determined about that it uses a variant of steiner tree, but I was still stuck at \(12\) points because I don't know how to deal with duplicated counts.

Implementing prob B and prob C was completely a mess. Both of the problems took me lots of time to debug. When I finally passed the samples for them, there was only \(3\) minute left.

Analysis

Strategy

Both days, I choose to implement non-fullscore solutions in the last \(90\) minutes. This strategy provides me with more time to solve more points. However, risks are that I might fail to implement all solutions before contest ends, which leads to an absolute disaster. Another widely used option is to implement the points one have already solved before leaving a problem. Since I think that I have decent implementation skill, maybe implementing at last is the right strategy for me.

Maybe I need to allocate time more carefully. I should avoid analyzing one problem for too long. If I get stuck, I should note down my current thoughts on draft paper, and then swap to another problem. A provincial team selection/NOI contest consists of \(4.5\) hours. If we spend \(2\) hours on prob A and implementation, we will have \(2.5\) hours for solving prob B and prob C. So a good time allocation is to spend \(30\) minutes on each of prob B and prob C first, and then decide which problem to analyze further in the rest \(1.5\) hours. In day 1, I spent too much time in prob B. If I spent some more time in prob C instead, maybe I would have got more than 8 pts.

Meta

I'm particular weak in DS. The prob B of day 1 is a problem about sqrt blocks, of which the difficulty isn't very high. If I was more familiar with sqrt data structures, I would've probably solved it. Similarly, from previous exercises I discovered that I'm weak in the previous topics:

  • Data structures
  • Number theory (and maths in general)
  • Strings

For data structures, strings and geometry, I need topic practice. For number theory, I think it's time for me to read Concrete Mathematics. I will buy the original version and start reading as soon as possible.

Training Plan & Goals (until July)

The most important thing is to patch up the topics I'm weak at, specifically:

  • Read Concrete Mathematics all through
  • Go through the hierarchy of DS, number theory and strings topics and practice some problems of each of them.

I still need to constantly improve my problemsolving ability. Aim for IGM before July. I should continue to grind Codeforces problems.

So we have two mainlines, and I guess it's nice to spend even time among these.

There are also some simulation contests. I should do some of them in order to improve my strategy and find my position, but in my opinion the main focus should still be the 2 aspects above, especially the first one.

Postscript

To be honest, I would really appreciate my performance in the provincial team contest. I solved every problem that I can solve, didn't miss any partial points, but still, the provincial team still seems almost impossible for me to qualify for. One big blunder in this season is the terrible NOIP score. So there's no need to be bothered about it and I should just focus on improvement based on the above two mainlines and head over the senior 2 season, where most participants have significant boost on their ability.

Look up at the sky and dream.

posted @ 2025-03-03 16:39  mindeveloped  阅读(63)  评论(1编辑  收藏  举报